
#pragma once

#include <windows.h>
#include <tchar.h>


//#pragma pack(1)
#pragma pack(push, 1) 
/* Declaration of FAT Boot Sector */
typedef struct {
	BYTE BS_jmpBoot[3];
	BYTE BS_OEMName[8];
	//BPB
	WORD BPB_BytesPerSec;
	BYTE BPB_SectorsPerCluster;
	WORD BPB_ReservedSectors;
	BYTE BPB_ZeroBytes[3];
	WORD BPB_NotUsed;
	BYTE BPB_MediaDescriptor;
	WORD BPB_ZeroBytes2;
	WORD BPB_SectorsPerTrack;
	WORD BPB_NumOfHeads;
	DWORD BPB_HiddenSectors;
	DWORD BPB_Unused2;
	DWORD BPBEx_Unused3;
	//BPB Extended
	LONGLONG BPBEx_TotalSectors;
	LONGLONG BPBEx_NumOfLogicalClusters;
	LONGLONG BPBEx_NumOfLogicalClustersMirr;
	DWORD BPBEx_ClustersPerFile;
	DWORD BPBEx_ClustersPerIndexBlock;
	LONGLONG BPBEx_VolumeSerial;
	DWORD BPBEx_Checksum;
} NTFS_BOOTSECTOR, *PNTFS_BOOTSECTOR;


// FAT 12/16 Bootsector structure
typedef struct
{
	BYTE BS_jmpBoot[3];				// 0x00
	BYTE BS_OEMName[8];				// 0x03
	WORD BPB_BytesPerSec;			// 0x0B
	BYTE BPB_SectorsPerCluster;		// 0x0D
	WORD BPB_ReservedSectors;		// 0x0E
	BYTE BPB_NumOfCopiesFAT;		// 0x10
	WORD BPB_MaxRootDirEntries;		// 0x11
	WORD BPB_NumOfSectors32MB;		// 0x13
	BYTE BPB_MediaDescriptor;	 	// 0x15
	WORD BPB_SectorsPerFAT;			// 0x16
	WORD BPB_SectorsPerTrack;		// 0x18
	WORD BPB_NumOfHeads;			// 0x1A
	DWORD BPB_NumOfHiddenSectors;	// 0x1C
	DWORD BPB_NumOfSectors;			// 0x20
	BYTE BS_DrvNum;					// 0x24
	BYTE BS_Reserved1;				// 0x25
	BYTE BS_BootSig;				// 0x26
	DWORD BS_VolID;					// 0x27
	BYTE BS_VolLab[11];				// 0x2B
	BYTE BS_FilSysType[8];			// 0x36				
} FAT_BOOTSECTOR, *PFAT_BOOTSECTOR;

// FAT32 Bootsector structure
typedef struct
{
	BYTE BS_jmpBoot[3];				// 0x00
	BYTE BS_OEMName[8];				// 0x03
	WORD BPB_BytesPerSec;			// 0x0B
	BYTE BPB_SectorsPerCluster;		// 0x0D
	WORD BPB_ReservedSectors;		// 0x0E
	BYTE BPB_NumOfCopiesFAT;		// 0x10
	WORD BPB_MaxRootDirEntries;		// 0x11
	WORD BPB_NumOfSectors32MB;		// 0x13
	BYTE BPB_MediaDescriptor;	 	// 0x15
	WORD BPB_SectorsPerFAT;			// 0x16
	WORD BPB_SectorsPerTrack;		// 0x18
	WORD BPB_NumOfHeads;			// 0x1A
	DWORD BPB_NumOfHiddenSectors;	// 0x1C
	DWORD BPB_NumOfSectors;			// 0x20
	DWORD BPB_FATSz32;				// 0x24
	WORD BPB_ExtFlags;				// 0x28
	WORD BPB_FSVer;					// 0x2A
	DWORD BPB_RootClus;				// 0x2C
	WORD BPB_FSInfo;				// 0x30
	WORD BPB_BkBootSec;				// 0x32
	BYTE BPB_Reserved[12];			// 0x34
	BYTE BS_DrvNum;					// 0x40
	BYTE BS_Reserved1;				// 0x41
	BYTE BS_BootSig;				// 0x42
	DWORD BS_VolID;					// 0x43
	BYTE BS_VolLab[11];				// 0x47
	BYTE BS_FilSysType;				// 0x52		
} FAT32_BOOTSECTOR, *PFAT32_BOOTSECTOR;
#pragma pack(pop)

/*
 * Constants
 */
enum FILESYSTEMTYPE {
	FS_NTFS = 1,
	FS_FAT = 2,
	FS_FAT32 = 3,
	FS_UNKNOWN = 255
};


typedef struct _STORAGE_DEVICE_DESCRIPTOR {
  ULONG  Version;
  ULONG  Size;
  UCHAR  DeviceType;
  UCHAR  DeviceTypeModifier;
  BOOLEAN  RemovableMedia;
  BOOLEAN  CommandQueueing;
  ULONG  VendorIdOffset;
  ULONG  ProductIdOffset;
  ULONG  ProductRevisionOffset;
  ULONG  SerialNumberOffset;
  STORAGE_BUS_TYPE  BusType;
  ULONG  RawPropertiesLength;
  UCHAR  RawDeviceProperties[1];
} STORAGE_DEVICE_DESCRIPTOR, *PSTORAGE_DEVICE_DESCRIPTOR;

typedef enum _STORAGE_PROPERTY_ID {
  StorageDeviceProperty = 0,
  StorageAccessAlignmentProperty,
  StorageAdapterProperty,
  StorageDeviceIdProperty,
  StorageDeviceUniqueIdProperty,
  StorageDeviceWriteCacheProperty
} STORAGE_PROPERTY_ID, *PSTORAGE_PROPERTY_ID;


typedef enum _STORAGE_QUERY_TYPE {
  PropertyStandardQuery = 0, 
  PropertyIncludeSwIds,
  PropertyExistsQuery, 
  PropertyMaskQuery, 
  PropertyQueryMaxDefined 
} STORAGE_QUERY_TYPE, *PSTORAGE_QUERY_TYPE;

typedef struct _STORAGE_PROPERTY_QUERY {
  STORAGE_PROPERTY_ID  PropertyId;
  STORAGE_QUERY_TYPE  QueryType;
  UCHAR  AdditionalParameters[1];
} STORAGE_PROPERTY_QUERY, *PSTORAGE_PROPERTY_QUERY;

/*
typedef enum _STORAGE_BUS_TYPE {
  BusTypeUnknown = 0x00,
  BusTypeScsi,
  BusTypeAtapi,
  BusTypeAta,
  BusType1394,
  BusTypeSsa,
  BusTypeFibre,
  BusTypeUsb,
  BusTypeRAID,
  BusTypeiScsi,
  BusTypeSas,
  BusTypeSata,
  BusTypeSd,
  BusTypeMmc,
  BusTypeMax,
  BusTypeMaxReserved = 0x7F
} STORAGE_BUS_TYPE, *PSTORAGE_BUS_TYPE;*/




// IOCTL control code
#define IOCTL_STORAGE_QUERY_PROPERTY   CTL_CODE(IOCTL_STORAGE_BASE, 0x0500, METHOD_BUFFERED, FILE_ANY_ACCESS)

/*
 * Declaration of functions
 */

// search for installed drives and fill data structure
void InitDriveInfo();
int GetNumOfInstalledDrives();

// returns the volume label of the specified drive
BOOL GetDriveVolumeName(int driveIndex, TCHAR* szDriveName, int iDriveNameLength);
// return the drive letter
BOOL GetDriveLetter(int driveIndex, TCHAR* szDriveLetter);
// get the used file system as string
BOOL GetDriveFileSystemName(int driveIndex, TCHAR* szFileSystemName, int iFileSystemNameLength);

// get the used file system as int
FILESYSTEMTYPE GetDriveFileSystem(int driveIndex);

// get serial number of drive
BOOL GetDriveSerialNumber(int driveIndex, DWORD* dwSerialNumber);
// get the drive type as string
BOOL GetDriveTypeString(int driveIndex, TCHAR* szDriveType, int iDriveTypeLength);

// fill in storage device information structure
BOOL GetDisksProperty(int driveIndex, PSTORAGE_DEVICE_DESCRIPTOR pDevDesc);
// returns given bus type as string
void AddBusTypeStr(STORAGE_BUS_TYPE bustype, TCHAR* szBusType, int iBusTypeLength);
// read the bootsector (512 bytes) of given device
BOOL ReadBootSector(int driveIndex, BYTE* pBootSector);